var i = 0;
var alarmHour;
var alarmMinute;
var secondsEnabled;
var secondsbattEnabled;
var alarmEnabled = "false";
var playing = false;
var AMPMstyle = false;
var alarmtime = 0;

function init()
{
    System.Gadget.Flyout.file = "flyout.html";
    System.Gadget.settingsUI = "Settings.html";
    System.Gadget.onSettingsClosed = loadParams;
    System.Gadget.Flyout.onHide = loadParams;

    bg.filters[0].addPoint(15,15,5,255,180,40,0);
    bg.filters[0].addPoint(15,15,5,55,0,255,0);
    bg.filters[0].addPoint(15,15,0,255,25,100,0);
    bg.filters[0].addAmbient(0,0,0, 20);
    bg.filters[0].addPoint(0,0,30,0,0,0,40);
    
    bg1.addShadow("black", 3, 70, 1, 1);
	loadParams();
}

function gadgetClick()
{
	if(playing)
	{
		Player.Controls.stop();
		playing = false;
	}
	else
		System.Gadget.Flyout.show = true;
}

function Blink()
{
	i= i + 0.18;
	if(i>2*Math.PI)
		i -= 2*Math.PI;
	x = 100*Math.sin(i);
	y = 30*Math.cos(i);
	x2 = 100*Math.sin(i-1.5);
	y2 = 30*Math.cos(i-1.5);
	x3 = 100*Math.sin(i-3.1);
	y3 = 30*Math.cos(i-3.1);

	
	bg.filters[0].moveLight(0, 10+x, 10+y, 15, 1);
	bg.filters[0].moveLight(1, 10+x2, 10+y2, 11, 1);
	bg.filters[0].moveLight(2, 10+x3, 10+y3, 11, 1);
	flare.style.top = y;
	flare.style.left = x;

	flare2.style.top = y2;
	flare2.style.left = x2;

	flare3.style.top = y3;
	flare3.style.left = x3;


	if(playing)
	{
		setTimeout("Blink();",50);	
	}
	else
	{
		bg.filters[0].changeStrength(0,0,1);
		bg.filters[0].changeStrength(1,0,1);
		bg.filters[0].changeStrength(2,0,1);
		flare.style.visibility = "hidden";
		flare2.style.visibility = "hidden";
		flare3.style.visibility = "hidden";
	}
}

function setColor(color, r,g,b)
{
	alarmcontent.style.color = ampmcontent.style.color = gadgetContent.style.color = color;
	bg.filters[0].changeColor(3, r,g,b, 1);
	bg.filters[0].changeColor(4, r,g,b, 1);
}



function nextRinging()
{
	var d = new Date();
	d.setHours(alarmHour);
	d.setMinutes(alarmMinute);
	d.setSeconds(alarmSecond);

	var now = new Date();
	if(d.getTime() > now.getTime())
		alarmtime = d.getTime();
	else
		alarmtime = d.getTime() + 24*3600*1000;

}

function setContentText() {
	var now = new Date();
	var hours = now.getHours();
	if(AMPMstyle)
	{
		if(hours >= 12)
		{
			hours -= 12;
			isAm = false;
		}
		else
			isAm = true;
		if(hours==0) hours = 12;
		setAm(isAm);
	}


	if(now.getTime() > alarmtime)
	{
		nextRinging();
		if(alarmEnabled == "true")
		{
			Player.settings.volume = 100;
			Player.URL = System.Gadget.Settings.readString("soundpath");
			Player.Controls.play();
			
			flare.style.visibility = "visible";
			flare2.style.visibility = "visible";
			flare3.style.visibility = "visible";
			bg.filters[0].changeStrength(0,100,1);
			bg.filters[0].changeStrength(1,100,1);
			bg.filters[0].changeStrength(2,100,1);
			playing = true;
			Blink();
		}
	}

	if(secondsEnabled=="true" && showSeconds())
	{
		if(!AMPMstyle)
			hours = padnumber(hours);
		gadgetContent.innerText = hours + ":" + padnumber(now.getMinutes()) + ":" + padnumber(now.getSeconds());
		setTimeout("setContentText()", 1000);
	}
	else
	{
		gadgetContent.innerText = padnumber(hours) + ":" + padnumber(now.getMinutes());
		var nextrefresh = 60 - now.getSeconds();
		var diff = (alarmtime - now.getTime())/1000;
		if(diff < nextrefresh)
			nextrefresh = (diff>0?diff:1);
		setTimeout("setContentText()", nextrefresh * 1000);
	}
}
function showSeconds()
{
	if(secondsbattEnabled=="true")
		if(!System.Machine.PowerStatus.isPowerLineConnected)
			return false;
	return true;
}
function setAm(isAm)
{
	ampmcontent.innerHTML = isAm? "AM":"&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;PM";
		
}

function padnumber(num)
{
	if(num < 10)
		return "0"+num;
	else
		return num;	
}

function ReadParam(paramname, defaultvalue)
{
    var ret = System.Gadget.Settings.read(paramname);
    if(ret === "")
    {
        ret = defaultvalue;
        System.Gadget.Settings.write(paramname, defaultvalue);
    }
    return ret;
}

function loadParams()
{
    if((new Date()).toLocaleTimeString().search("AM|PM")!=-1)
	    AMPMstyle = true;
    else
	    AMPMstyle = false;

	ReadParam("soundpath", System.Environment.getEnvironmentVariable("SystemRoot") + "\\Media\\tada.wav");

    alarmHour = ReadParam("hour",0);
    alarmMinute = ReadParam("minute",0);
    alarmSecond = ReadParam("second",0);
    alarmEnabled = ReadParam("alarmenabled", "false");
    secondsEnabled = ReadParam("secondsenabled", "true");
    secondsbattEnabled = ReadParam("secondsbattenabled", "false");

    if(alarmEnabled=="true")
    {
        
        var alHour = alarmHour;
        var alAmpm = " AM";
        if(AMPMstyle)
        {
            alarmcontent.style.left = 62;
            alarmcontent.style.width = 58;
            if(alHour >= 12)
            {
                alHour -=12;
                alAmpm = " PM";
            }
            if(alHour==0)
                alHour = 12;
	        alarmhour.innerText = alHour + ":" + padnumber(alarmMinute) + alAmpm;
	    }
	    else
	        alarmhour.innerText = padnumber(alHour) + ":" + padnumber(alarmMinute);
	    alarmcontent.style.visibility = "visible";
    }
    else
	    alarmcontent.style.visibility = "hidden";

    var colorSetting = ReadParam("color","red");

    blurintensity = ReadParam("blurintensity", "1");
    gadgetContent.style.filter = "progid:DXImageTransform.Microsoft.Blur(PixelRadius='"+ blurintensity +"', MakeShadow='false', ShadowOpacity='0.25')";

    updateColor(colorSetting);		

    nextRinging();
    setContentText();
}
